# praktisch für Anki
# umwandeln von vokabular nach kanji lernliste
# copyright christian rusche, 2012

# - dependencies --------------------------------------
import csv

# - constants -----------------------------------------

FILE_NAME_IN = 'alle.txt'
FILE_NAME_OUT = 'kanji.txt'

KANA = set(" -?々ィォッゃょるわんカクコシセタいデえニがハぐビごプじホぜミだャつョとルぬワばンぴへぼむやよれイエガグゴジゼダツトかヌくバこピしヘせボたムっヤでヨにレはびぷほーみめゅらろキケサスソチあヅうドおネぎパげフざベずポぞメぢュてラなロのひぶぺまもゆりをアウオギゲザズゾヂテナきノけヒさブすペそマちモづユどリねぱヲふべぽ")

# - load data -----------------------------------------

translation = {}
reading = {}

with open(FILE_NAME_IN, 'r', encoding='utf-8') as file_in:
    for row in file_in:
        split = row[:-1].split('\t')
        translation[split[0]] = split[1]
        reading[split[0]] = split[2]

# - find all unique kanjis -----------------------------

kanji = {}
for word in translation:
    for char in word:
        if char not in kanji and char not in KANA:
            kanji[char] = []

# - add words to kanji ---------------------------------

for k, words in kanji.items():
    for word in translation:
        if k in word:
            words.append((word, reading[word], translation[word]))

# - write data -----------------------------------------

with open(FILE_NAME_OUT, 'w', encoding='utf-8') as file_out:
    for k, words in kanji.items():
        nice = ""
        for w in words:
            nice += '%s[%s] %s<br>' % w
        file_out.write('%s\t%s\n' % (k, nice))

